Option Compare Database

Private Sub AgyStatusCmb_Change()
AgyStatusCkb = True

End Sub

Private Sub AgyTypeCmb_Change()
AgyTypeCkb = True
End Sub

Private Sub CPFunctionCmb_Change()
CPFunctionCkb = True
End Sub

Private Sub Clear_Click()
'clear combo boxes
OptionsIncludeAddInfo = 1
AgyStatusCmb = Null
AgyTypeCmb = Null
CPFunctionCmb = Null
USCFunctionCmb = Null
EmployeeCategoryCmb = Null
HasPSCmb = Null
HasHCmb = Null
OtherRTSystemsCmb = Null
SSSCtrCmb = Null
SSSCtrStatusCmb = Null

'clear check boxes
AgyStatusCkb = Null
AgyTypeCkb = Null
CPFunctionCkb = Null
USCFunctionCkb = Null
EmployeeCategoryCkb = Null
HasPSCkb = Null
HasHCkb = Null
OtherRTSystemsCkb = Null
SSSCtrCkb = Null
SSSCtrStatusCkb = Null
EffTermDateCkb = Null
BulletinCkb = Null



End Sub

Private Sub EmployeeCategoryCmb_Change()
EmployeeCategoryCkb = True

End Sub

Private Sub HasPSCmb_Change()
HasPSCkb = True
End Sub
Private Sub HasHCmb_Change()
HasHCkb = True
End Sub

Private Sub OtherRTSystemsCmb_Change()
OtherRTSystemsCkb = True

End Sub

Public Sub Run_Click()

'************************************************************************************************************
'
'   QUERY BY FORM
'   inputs: user selections
'   outputs: datasheet view (qryByForm) displaying query results built by user through form
'   description: User selects which items are to be displayed in "thier query"
'                using the form called frmQryMaker.
'                This code then dynamically generates an SQL statment unique to user input.
'   author: S. Varela, student assistant
'  inital date created: Jan/2012
'
'************************************************************************************************************

'Declerations
Dim strSQL As String
Dim userSQL As String
Dim strWhere As String
Dim rcrdSet As DAO.Recordset
Dim db As DAO.Database
Dim qdf As DAO.QueryDef
Set db = CurrentDb
Set qdf = db.QueryDefs("qryMaker") ' opening a pre saved query
                                    ' if there exists code within the query,
                                    ' then overwrite.


Dim qryName As String ' pre made query in which all information is extracted, depending on user's choice

Dim DEFstrSQL As String  'default SQL string. Agy info is always shown
Dim ADDstrSQL As String ' additional SQL string. Chosen by user with check boxes to include addional information
Dim DEFstrSQL_PK As String ' Merged_To Primary Key at the very end-- serves just as extra information.


Dim ERCD_NAME As String
ERCD_NAME = "AS [ERDC]"


Select Case OptionsIncludeAddInfo ' radio button case selection
       
       Case 1 ': user has selected "None" for addional information to be included
                
                qryName = "qryPreMaker"
                ADDstrSQL = ""
                
       Case 2 ': user has selected "Agy Address" for addional information to be included ~

                qryName = "[qryPreMaker_w/Address]"
                ADDstrSQL = " ," & qryName & ".Mailing, " & qryName & ".Physical, " & qryName & _
                             ".Address1, " & qryName & ".Address2, " & qryName & ".City, " & _
                             qryName & ".State, " & qryName & ".Address_Notes "
        
       Case 3  ': user has selected "Agy Address & Contacts " for addional information to be included
                qryName = "[qryPreMaker_w/Address&Contacts]"
                ADDstrSQL = " ," & qryName & ".Mailing, " & qryName & ".Physical, " & _
                            qryName & ".Agy_Address1, " & _
                            qryName & ".Agy_Address2, " & _
                            qryName & ".Agy_City, " & _
                            qryName & ".Agy_State, " & _
                            qryName & ".Address_Notes, " & _
                            qryName & ".First_name, " & qryName & ".Last_name, " & _
                            qryName & ".MI, " & qryName & ".Position, " & qryName & ".Email, " & _
                            qryName & ".Telephone1, " & qryName & ".Extension1, " & _
                            qryName & ".Telephone2, " & qryName & ".Extension2, " & _
                            qryName & ".FAX, " & qryName & ".Contact_Notes, " & _
                            qryName & ".[Multiple Agy Contact] "

       
       Case 4 ': user has selected "Contacts" for addional information to be included
                qryName = "[qryPreMaker_w/Contacts]"
                ADDstrSQL = " ," & qryName & ".First_Name, " & qryName & ".Last_Name, " & _
                            qryName & ".MI, " & qryName & ".Position, " & qryName & ".Email, " & _
                            qryName & ".Telephone1, " & qryName & ".Extension1, " & _
                            qryName & ".Telephone2, " & qryName & ".Extension2, " & _
                            qryName & ".FAX, " & qryName & ".Contact_Notes, " & _
                            qryName & ".Address1, " & qryName & ".Address2, " & _
                            qryName & ".City, " & qryName & ".State, " & qryName & ".ZIP_Code "

    
End Select
    

    DEFstrSQL = qryName & ".PS_ID, " & qryName & ".ERDC, " & qryName & ".DST, " & qryName & ".Org_ID, " & _
                     qryName & ".Agy_Name, " & qryName & ".SSID, " & _
                     qryName & ".FEIN "
    DEFstrSQL_PK = ", " & qryName & ".Merged_To "

'Creating the SQL Statement
               
                'SELECT
                     'selecting all generic information form qryPreMaker
                strSQL = "SELECT " & DEFstrSQL
                    'Me.txtSQL = strSQL
                userSQL = Find_User_Selected(qryName)
                strSQL = strSQL & userSQL & ADDstrSQL & DEFstrSQL_PK
                      'Me.txtSQL = strSQL
                      
               
            
                'FROM
                strSQL = strSQL & "FROM " & qryName & " "
                    'Me.txtSQL = strSQL
                'GROUP BY
                strSQL = strSQL & "GROUP BY " & DEFstrSQL
                strSQL = strSQL & userSQL & ADDstrSQL & DEFstrSQL_PK
                
                'HAVING
                 strSQL = strSQL & Find_User_Input(qryName)
                 
                'ORDER BY
                 strSQL = strSQL & "ORDER BY " & qryName & ".Agy_Name "
                 
               
                 
    qdf.SQL = strSQL
    Me.txtSQL = strSQL
    
    'closes query if its already open (allows for refresh)
    DoCmd.Close acQuery, "qryMaker", acSaveNo

    
    DoCmd.OpenQuery "qryMaker", , acReadOnly
    
    Set qdf = Nothing
    Set db = Nothing
    

    Call MakeTbl(1) ' turns the query into a table so can have a row #
       
End Sub
Private Function MakeTbl(Cancel As Integer)

'this funtion makes the query into a table

'table name includes PSons name
'so there will be no conflict if multiple people execute the code at the exact same time
'note, every individual will have thier own table

Dim tblName As String
tblName = "tblQueryMaker" & [Forms]![frmMainMenu]![txtUserID]



Dim tblExists As Integer

tblExists = fExistTable(tblName)

'if table aleady exists and is open
'then close and delete it
If tblExists <> 0 Then

DoCmd.Close acTable, tblName, acSaveNo
DoCmd.DeleteObject acTable, tblName

End If

'*******************************************
'            ERROR OCCURS HERE
'*******************************************

Dim strSQL As String
strSQL = "INSERT INTO " & tblName & " SELECT * FROM qryMaker;"

'MsgBox strSQL, vbInformation ' for debugging

Debug.Print strSQL



    DoCmd.RunSQL (strSQL)

'adds autonum field for row #

    Set curDatabase = CurrentDb
    Set tblTest = curDatabase.TableDefs(tblName)
                
    strField = "Row#"
    
    Set fldNew = tblTest.CreateField(strField, dbLong)
    With fldNew
    .Attributes = .Attributes Or dbAutoIncrField
    End With
    
    tblTest.Fields.Append fldNew
    DoCmd.OpenTable tblName, , acReadOnly
  End Function

Function fExistTable(strTableName As String) As Integer
Dim db As Database
Dim i As Integer
    Set db = DBEngine.Workspaces(0).Databases(0)
    fExistTable = False
    db.TableDefs.Refresh
    For i = 0 To db.TableDefs.Count - 1
        If strTableName = db.TableDefs(i).Name Then
            'Table Exists
            fExistTable = True
            Exit For
        End If
    Next i
    Set db = Nothing
End Function




Private Function Find_User_Input(qryName As String) As String
' this sub routine appends filters by user input to the SQL statment
Dim Count As Integer    ' checks to see if need a AND or not for having multiple search criterias
Count = 0
Find_User_Input = " "

If AgyStatusCkb Then

    If Not IsNull([Forms]![frmQueryMaker]![AgyStatusCmb]) Then
        If Count = 0 Then
            Find_User_Input = Find_User_Input & "HAVING (((" & qryName & ".Agy_Status)=[Forms]![frmQueryMaker]![AgyStatusCmb])"
        Else
            Find_User_Input = Find_User_Input & " AND ((" & qryName & ".Agy_Status)=[Forms]![frmQueryMaker]![AgyStatusCmb])"
         End If
         Count = Count + 1
     End If
                                            
End If

'----
If AgyTypeCkb Then
    
    If Not IsNull([Forms]![frmQueryMaker]![AgyTypeCmb]) Then
    
        If Count = 0 Then
            Find_User_Input = Find_User_Input & "HAVING (((" & qryName & ".Agy_Type)=[Forms]![frmQueryMaker]![AgyTypeCmb])"
        Else
             Find_User_Input = Find_User_Input & "AND ((" & qryName & ".Agy_Type)=[Forms]![frmQueryMaker]![AgyTypeCmb])"
        End If
        Count = Count + 1
    End If

End If

'----
If CPFunctionCkb Then
    
    If Not IsNull([Forms]![frmQueryMaker]![CPFunctionCmb]) Then
        If Count = 0 Then
            Find_User_Input = Find_User_Input & "HAVING (((" & qryName & ".PS_Function)=[Forms]![frmQueryMaker]![CPFunctionCmb])"
            Else
             Find_User_Input = Find_User_Input & "AND ((" & qryName & ".PS_Function)=[Forms]![frmQueryMaker]![CPFunctionCmb])"
        End If
        Count = Count + 1
    End If

End If

'----
If USCFunctionCkb Then
    If Not IsNull([Forms]![frmQueryMaker]![USCFunctionCmb]) Then
        If Count = 0 Then
            Find_User_Input = Find_User_Input & "HAVING (((" & qryName & ".US_Function)=[Forms]![frmQueryMaker]![USCFunctionCmb])"
            Else
             Find_User_Input = Find_User_Input & "AND ((" & qryName & ".US_Function)=[Forms]![frmQueryMaker]![USCFunctionCmb])"
        End If
        Count = Count + 1
    End If

End If


'----
If EmployeeCategoryCkb Then
    
   If Not IsNull([Forms]![frmQueryMaker]![EmployeeCategoryCmb]) Then
        If Count = 0 Then
            Find_User_Input = Find_User_Input & "HAVING (((" & qryName & ".EE_Category)=[Forms]![frmQueryMaker]![EmployeeCategoryCmb])"
            Else
             Find_User_Input = Find_User_Input & "AND ((" & qryName & ".EE_Category)=[Forms]![frmQueryMaker]![EmployeeCategoryCmb])"
        End If
        Count = Count + 1
    End If

End If

'-----
If HasPSCkb Then
    
    If Not IsNull([Forms]![frmQueryMaker]![HasPSCmb]) Then
        If Count = 0 Then
            Find_User_Input = Find_User_Input & "HAVING (((" & qryName & ".Has_PS)=[Forms]![frmQueryMaker]![HasPSCmb])"
            Else
             Find_User_Input = Find_User_Input & "AND ((" & qryName & ".Has_PS)=[Forms]![frmQueryMaker]![HasPSCmb])"
        End If
        Count = Count + 1
    End If
End If

'-----
If HasHCkb Then
    
    If Not IsNull([Forms]![frmQueryMaker]![HasHCmb]) Then
        If Count = 0 Then
            Find_User_Input = Find_User_Input & "HAVING (((" & qryName & ".Has_H)=[Forms]![frmQueryMaker]![HasHCmb])"
            Else
             Find_User_Input = Find_User_Input & "AND ((" & qryName & ".Has_H)=[Forms]![frmQueryMaker]![HasHCmb])"
        End If
        Count = Count + 1
    End If
End If

'----
If OtherRTSystemsCkb Then

    If Not IsNull([Forms]![frmQueryMaker]![OtherRTSystemsCmb]) Then
        If Count = 0 Then
            Find_User_Input = Find_User_Input & "HAVING (((" & qryName & ".Other_RT_System)=[Forms]![frmQueryMaker]![OtherRTSystemsCmb])"
            Else
            Find_User_Input = Find_User_Input & "AND ((" & qryName & ".Other_RT_System)=[Forms]![frmQueryMaker]![OtherRTSystemsCmb])"
        End If
    Count = Count + 1
    End If
    
End If

'----
If SSSCtrCkb Then

    If Not IsNull([Forms]![frmQueryMaker]![SSSCtrCmb]) Then
        If Count = 0 Then
            Find_User_Input = Find_User_Input & "HAVING (((" & qryName & ".SS_Ctr)=[Forms]![frmQueryMaker]![SSSCmb])"
            Else
             Find_User_Input = Find_User_Input & "AND ((" & qryName & ".SS_Ctr)=[Forms]![frmQueryMaker]![SSSCtrCmb])"
        End If
    Count = Count + 1
    End If
    
End If

'----
If SSSCtrStatusCkb Then

    If Not IsNull([Forms]![frmQueryMaker]![SSSCtrStatusCmb]) Then
        If Count = 0 Then
            Find_User_Input = Find_User_Input & "HAVING (((" & qryName & ".SS_Status)=[Forms]![frmQueryMaker]![SSSCtrStatusCmb])"
            Else
             Find_User_Input = Find_User_Input & "AND ((" & qryName & ".SS_Status)=[Forms]![frmQueryMaker]![SSSCtrStatusCmb])"
        End If
    Count = Count + 1
    End If
    
End If

'----


If Count > 0 Then
    
 Find_User_Input = Find_User_Input & ")"
 End If


End Function

Private Function Find_User_Selected(qryName As String) As String
' this sub routine appends columns from the user to the SQL statment

Find_User_Selected = " "

If AgyStatusCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".Agy_Status "
End If

If AgyTypeCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".Agy_Type "
End If

If CPFunctionCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".PS_Function "
End If

If USCFunctionCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".US_Function "
End If

If EmployeeCategoryCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".EE_Category "
End If

If HasPSCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".Has_PS "
End If

If HasHCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".Has_H "
End If

If OtherRTSystemsCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".Other_RT_System "
End If

If SSSCtrCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".SS_Ctr "
End If

If SSSCtrStatusCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".SS_Status "
End If

If EffTermDateCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".EFF_DT "
Find_User_Selected = Find_User_Selected & ", " & qryName & ".Term_DT "
End If


If BulletinCkb Then
Find_User_Selected = Find_User_Selected & ", " & qryName & ".Bulletin "

End If




End Function

Private Sub SSSCtrCmb_Change()
SSSCtrCkb = True
End Sub

Private Sub SSSCtrStatusCmb_Change()
SSSCtrStatusCkb = True

End Sub

Private Sub USCFunctionCmb_Change()
    USCFunctionCkb = True
End Sub

